< Back
 

# Packages

-  package root
  Definition Classes
    root
-  package uk
  Definition Classes
    root
-  package gov
  Definition Classes
    uk
-  package hmrc
  Definition Classes
    gov
-  package ct
  Definition Classes
    hmrc
-  package computations
  Definition Classes
    ct
-  package Validators
  Definition Classes
    computations
-  package calculations
  Definition Classes
    computations
-  package capitalAllowanceAndSBA
  Definition Classes
    computations
-  package formats
  Definition Classes
    computations
-  package lowEmissionCars
  Definition Classes
    computations
-  package nir
  Definition Classes
    computations
-  package retriever
  Definition Classes
    computations
- AP1
- AP2
- AP3
- Building
- CP1
- CP100
- CP101
- CP102
- CP103
- CP104
- CP106
- CP107
- CP108
- CP111
- CP113
- CP114
- CP115
- CP116
- CP117
- CP118
- CP14
- CP15
- CP16
- CP17
- CP18
- CP186
- CP19
- CP2
- CP20
- CP21
- CP22
- CP23
- CP234
- CP235
- CP237
- CP238
- CP238a
- CP239
- CP24
- CP240
- CP245
- CP246
- CP247
- CP248
- CP249
- CP25
- CP251
- CP252
- CP253
- CP256
- CP257
- CP258
- CP259
- CP26
- CP263
- CP264
- CP265
- CP266
- CP27
- CP273
- CP274
- CP278
- CP279
- CP28
- CP281
- CP281a
- CP281b
- CP281c
- CP281d
- CP282
- CP283
- CP283a
- CP283b
- CP283c
- CP283d
- CP284
- CP285
- CP286
- CP286a
- CP286b
- CP287
- CP288
- CP288a
- CP288b
- CP289
- CP29
- CP290
- CP290a
- CP290b
- CP290c
- CP290d
- CP291
- CP292
- CP293
- CP294
- CP295
- CP296
- CP297
- CP298
- CP30
- CP301
- CP3010
- CP302
- CP3020
- CP303
- CP3030
- CP305
- CP31
- CP32
- CP33
- CP34
- CP35
- CP36
- CP37
- CP38
- CP39
- CP40
- CP43
- CP44
- CP45
- CP46
- CP47
- CP48
- CP49
- CP50
- CP500
- CP501
- CP502
- CP503
- CP504
- CP505
- CP506
- CP507
- CP508
- CP509
- CP51
- CP510
- CP511
- CP512
- CP513
- CP514
- CP515
- CP52
- CP53
- CP54
- CP55
- CP56
- CP57
- CP58
- CP59
- CP6
- CP666
- CP667
- CP668
- CP669
- CP670
- CP671
- CP672
- CP673
- CP674
- CP7
- CP78
- CP79
- CP8
- CP80
- CP81
- CP81Input
- CP82
- CP83
- CP84
- CP85
- CP86
- CP87
- CP87Input
- CP88
- CP89
- CP90
- CP91
- CP91Input
- CP92
- CP93
- CP95
- CP96
- CP98
- CP980
- CP981
- CP982
- CP983
- CP984
- CP986
- CP99
- CP997
- CP997Abstract
- CP997NI
- CP997c
- CP997d
- CP997e
- CP998
- CP999
- CPAux1
- CPAux2
- CPAux3
- CPQ10
- CPQ1000
- CPQ11
- CPQ117
- CPQ17
- CPQ18
- CPQ19
- CPQ20
- CPQ21
- CPQ321
- CPQ7
- CPQ8
- HmrcAccountingPeriod
- SBA01
- SBAHelper

c

uk.gov.hmrc.ct.computations

# Building 

###

#### case class Building(description: Option[String], firstLineOfAddress: Option[String], postcode: Option[String], earliestWrittenContract: Option[LocalDate], nonResidentialActivityStart: Option[LocalDate], costsClaimedInThisPeriod: Option[Boolean], cost: Option[Int], claim: Option[Int], broughtForward: Option[Int] = None, carriedForward: Option[Int] = None, claimNote: Option[String] = None) extends ValidatableBox[ComputationsBoxRetriever] with ExtraValidation with SBAHelper with SBACalculator with Product with Serializable

Linear Supertypes
Serializable, Serializable, Product, Equals, SBACalculator, AccountingPeriodHelper, NumberRounding, SBAHelper, ValidatableBox[ComputationsBoxRetriever], ExtraValidation, Validators, AnyRef, Any
 
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. Building
2. Serializable
3. Serializable
4. Product
5. Equals
6. SBACalculator
7. AccountingPeriodHelper
8. NumberRounding
9. SBAHelper
10. ValidatableBox
11. ExtraValidation
12. Validators
13. AnyRef
14. Any

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Instance Constructors

1.  new Building(description: Option[String], firstLineOfAddress: Option[String], postcode: Option[String], earliestWrittenContract: Option[LocalDate], nonResidentialActivityStart: Option[LocalDate], costsClaimedInThisPeriod: Option[Boolean], cost: Option[Int], claim: Option[Int], broughtForward: Option[Int] = None, carriedForward: Option[Int] = None, claimNote: Option[String] = None)

### Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##(): Int
   Definition Classes
     AnyRef → Any
3.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
4.  def And(predicates: () ⇒ Boolean*)(): Boolean
   Attributes
     protected
   Definition Classes
     Validators
5.  def Or(predicates: () ⇒ Boolean*)(): Boolean
   Attributes
     protected
   Definition Classes
     Validators
6.  def accountingPeriodDaysInFinancialYear(year: Int, accountingPeriod: HmrcAccountingPeriod): BigDecimal
   Definition Classes
     AccountingPeriodHelper
7.  def accountingPeriodSpansTwoFinancialYears(accountingPeriod: HmrcAccountingPeriod): Boolean
   Definition Classes
     AccountingPeriodHelper
8.  def apportionedCostOfBuilding(cost: BigDecimal, daysInTheYear: Int, rateForTy: SBARateForTaxYear): BigDecimal
   Definition Classes
     SBACalculator
9.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
10.  def atLeastOneBoxHasValue(boxId: String, boxes: OptionalCtValue[_]*)(): Set[CtValidation]
    Attributes
      protected
    Definition Classes
      ValidatableBox
11.  def belowMin(value: Option[Int], min: Int = MIN_MONEY_AMOUNT_ALLOWED)(): Set[CtValidation]
    Attributes
      protected
    Definition Classes
      Validators
12.  def belowMinWithMax(value: Option[Int], max: Int, min: Int = MIN_MONEY_AMOUNT_ALLOWED)(): Set[CtValidation]
    Attributes
      protected
    Definition Classes
      Validators
13.  val boxId: String
    Attributes
      protected
    Definition Classes
      Validators
14.  val broughtForward: Option[Int]
15.  val broughtForwardId: String
    Definition Classes
      SBAHelper
16.  def cannotExistErrorIf(predicate: ⇒ Boolean)(): Set[CtValidation]
    Attributes
      protected
    Definition Classes
      Validators
17.  val carriedForward: Option[Int]
18.  val carriedForwardId: String
    Definition Classes
      SBAHelper
19.  val claim: Option[Int]
20.  val claimId: String
    Definition Classes
      SBAHelper
21.  val claimNote: Option[String]
22.  val claimNoteId: String
    Definition Classes
      SBAHelper
23.  def clone(): AnyRef
    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... ) @native()
24.  def collectErrors(predicates: () ⇒ Set[CtValidation]*): Set[CtValidation]
    Attributes
      protected
    Definition Classes
      Validators
25.  def collectWithBoxId(newBoxId: String)(errors: Set[CtValidation]): Set[CtValidation]
    Attributes
      protected
    Definition Classes
      Validators
26.  val cost: Option[Int]
27.  val costId: String
    Definition Classes
      SBAHelper
28.  val costsClaimedInThisPeriod: Option[Boolean]
29.  val dateLowerBound: LocalDate
    Definition Classes
      SBAHelper
30.  def daysBetween(start: LocalDate, end: LocalDate): Int
    Definition Classes
      AccountingPeriodHelper
31.  def daysInAccountingPeriod(accountingPeriod: HmrcAccountingPeriod): Int
    Definition Classes
      AccountingPeriodHelper
32.  val description: Option[String]
33.  val descriptionId: String
    Definition Classes
      SBAHelper
34.  val earliestWrittenContract: Option[LocalDate]
35.  val earliestWrittenContractId: String
    Definition Classes
      SBAHelper
36.  def endingFinancialYear(date: EndDate): Int
    Definition Classes
      AccountingPeriodHelper
37.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
38.  def errorMessage[A](messageKey: String, errorArguments: Seq[A] = Seq.empty): Set[CtValidation]
    Attributes
      protected
    Definition Classes
      Validators
39.  val exampleUpperBoundDate: LocalDate
    Definition Classes
      SBAHelper
40.  def exceedsMax(value: Option[Int], max: Int = MAX_MONEY_AMOUNT_ALLOWED)(): Set[CtValidation]
    Attributes
      protected
    Definition Classes
      Validators
41.  def failIf(condition: ⇒ Boolean)(validationErrors: ⇒ Set[CtValidation])(): Set[CtValidation]
    Attributes
      protected
    Definition Classes
      Validators
42.  val filingPeriodQuestionId: String
    Definition Classes
      SBAHelper
43.  def finalize(): Unit
    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
44.  def financialYearForDate(date: LocalDate): Int
    Definition Classes
      AccountingPeriodHelper
45.  def financialYearStartingIn(year: Int): (LocalDate, LocalDate)
    Definition Classes
      AccountingPeriodHelper
46.  val firstLineOfAddress: Option[String]
47.  val firstLineOfAddressId: String
    Definition Classes
      SBAHelper
48.  def getApportionedRates(apStartDate: LocalDate, apEndDate: LocalDate): Int
49.  final def getClass(): Class[_]
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
50.  def getDaysIntheYear(apStartDate: LocalDate): Int
    Definition Classes
      SBACalculator
51.  def getSbaDetails(apStartDate: LocalDate, apEndDate: LocalDate, maybeFirstUsageDate: Option[LocalDate], maybeCost: Option[Int]): Option[SbaResults]
    Definition Classes
      SBACalculator
52.  def isEarliestWrittenContractAfterAPStart(contractDate: LocalDate, apStartDate: LocalDate): Boolean
    Definition Classes
      SBACalculator
53.  def isEmpty(value: Option[_]): Boolean
    Attributes
      protected
    Definition Classes
      Validators
54.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
55.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
56.  def nonEmpty(value: Option[_]): Boolean
    Attributes
      protected
    Definition Classes
      Validators
57.  val nonResActivityId: String
    Definition Classes
      SBAHelper
58.  val nonResidentialActivityStart: Option[LocalDate]
59.  final def notify(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
60.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
61.  def passIf(condition: ⇒ Boolean)(validationErrors: ⇒ Set[CtValidation])(): Set[CtValidation]
    Attributes
      protected
    Definition Classes
      Validators
62.  val postCodeRegex: String
    Attributes
      protected
    Definition Classes
      ExtraValidation
63.  val postcode: Option[String]
64.  val postcodeId: String
    Definition Classes
      SBAHelper
65.  val rateAfterTy2020: SBARateForTaxYear
    Definition Classes
      SBACalculator
66.  val ratePriorTy2020: SBARateForTaxYear
    Definition Classes
      SBACalculator
67.  def replaceBoxId(newBoxId: String, errors: () ⇒ Set[CtValidation])(): Set[CtValidation]
    Attributes
      protected
    Definition Classes
      Validators
68.  def requiredErrorIf(predicate: ⇒ Boolean)(): Set[CtValidation]
    Attributes
      protected
    Definition Classes
      Validators
69.  def roundedToInt(value: BigDecimal): Int
    Definition Classes
      NumberRounding
70.  def roundedToIntHalfDown(value: BigDecimal): Int
    Definition Classes
      NumberRounding
71.  def roundedToIntHalfUp(value: BigDecimal): Int
    Definition Classes
      NumberRounding
72.  def roundedTwoDecimalPlaces(value: BigDecimal): BigDecimal
    Definition Classes
      NumberRounding
73.  val sba01BoxId: String
    Definition Classes
      SBAHelper
74.  def startingFinancialYear(date: StartDate): Int
    Definition Classes
      AccountingPeriodHelper
75.  def sumAmount(xs: List[Option[Int]]): Option[Int]
    Definition Classes
      SBACalculator
76.  final def synchronized[T0](arg0: ⇒ T0): T0
    Definition Classes
      AnyRef
77.  def validate(boxRetriever: ComputationsBoxRetriever): Set[CtValidation]
    Definition Classes
      Building → ValidatableBox
78.  def validateAccountingPeriod(accountingPeriod: HmrcAccountingPeriod): Unit
    Definition Classes
      AccountingPeriodHelper
79.  def validateAllFilledOrEmptyStrings(boxId: String, allBoxes: Set[CtValue[String]])(): Set[CtValidation]
    Attributes
      protected
    Definition Classes
      ValidatableBox
80.  def validateAllFilledOrEmptyStringsForBankDetails(boxRetriever: RepaymentsBoxRetriever, boxId: String)(): Set[CtValidation]
    Attributes
      protected
    Definition Classes
      ValidatableBox
81.  def validateAsMandatory[U](box: CtValue[U] with CtBoxIdentifier)(): Set[CtValidation]
    Attributes
      protected
    Definition Classes
      ValidatableBox
82.  def validateAsMandatory[A](boxId: String, value: Option[A])(): Set[CtValidation]
    Definition Classes
      ExtraValidation
83.  def validateBooleanAsMandatory(boxId: String, box: OptionalBooleanIdBox)(): Set[CtValidation]
    Attributes
      protected
    Definition Classes
      ValidatableBox
84.  def validateBooleanAsTrue(boxId: String, box: OptionalBooleanIdBox)(): Set[CtValidation]
    Attributes
      protected
    Definition Classes
      ValidatableBox
85.  def validateCoHoStringReturnIllegalChars(boxId: String, value: String, errorCodeBoxId: Option[String] = None)(): Set[CtValidation]
    Attributes
      protected
    Definition Classes
      ValidatableBox
86.  def validateCoHoStringReturnIllegalChars(boxId: String, box: OptionalStringIdBox)(): Set[CtValidation]
    Attributes
      protected
    Definition Classes
      ValidatableBox
87.  def validateCohoNameField(boxId: String, box: StringIdBox)(): Set[CtValidation]
    Attributes
      protected
    Definition Classes
      ValidatableBox
88.  def validateCohoOptionalNameField(boxId: String, box: OptionalStringIdBox)(): Set[CtValidation]
    Attributes
      protected
    Definition Classes
      ValidatableBox
89.  def validateDateAsAfter(boxId: String, box: OptionalDateIdBox, dateToCompare: LocalDate)(): Set[CtValidation]
    Attributes
      protected
    Definition Classes
      ValidatableBox
90.  def validateDateAsBefore(boxId: String, box: OptionalDateIdBox, dateToCompare: LocalDate)(): Set[CtValidation]
    Attributes
      protected
    Definition Classes
      ValidatableBox
91.  def validateDateAsBetweenInclusive(boxId: String, date: Option[LocalDate], minDate: LocalDate, maxDate: LocalDate, messageId: String)(): Set[CtValidation]
    Attributes
      protected
    Definition Classes
      ValidatableBox
92.  def validateDateAsBetweenInclusive(boxId: String, box: OptionalDateIdBox, minDate: LocalDate, maxDate: LocalDate)(): Set[CtValidation]
    Attributes
      protected
    Definition Classes
      ValidatableBox
93.  def validateDateAsBlank(boxId: String, box: OptionalDateIdBox)(): Set[CtValidation]
    Attributes
      protected
    Definition Classes
      ValidatableBox
94.  def validateDateAsMandatory(boxId: String, date: Option[LocalDate], messageId: String)(): Set[CtValidation]
    Attributes
      protected
    Definition Classes
      ValidatableBox
95.  def validateDateAsMandatory(boxId: String, box: OptionalDateIdBox)(): Set[CtValidation]
    Attributes
      protected
    Definition Classes
      ValidatableBox
96.  def validateDateIsInclusive(boxId: String, minDate: LocalDate, dateToCompare: Option[LocalDate], maxDate: LocalDate): Set[CtValidation]
    Definition Classes
      ExtraValidation
97.  def validateIntegerAsBlank(boxId: String, box: OptionalIntIdBox)(): Set[CtValidation]
    Attributes
      protected
    Definition Classes
      ValidatableBox
98.  def validateIntegerAsMandatory(boxId: String, box: OptionalIntIdBox)(): Set[CtValidation]
    Attributes
      protected
    Definition Classes
      ValidatableBox
99.  def validateIntegerRange(boxId: String, box: OptionalIntIdBox, min: Int, max: Int)(): Set[CtValidation]
    Attributes
      protected
    Definition Classes
      ValidatableBox
100.  def validateMoney(value: Option[Int], min: Int = -99999999, max: Int = 99999999)(): Set[CtValidation]
     Attributes
       protected
     Definition Classes
       Validators
101.  def validateNotEmptyStringByLength(boxId: String, value: String, min: Int, max: Int)(): Set[CtValidation]
     Definition Classes
       ValidatableBox
102.  def validateNotEmptyStringByLengthMin(boxId: String, value: String, min: Int)(): Set[CtValidation]
     Definition Classes
       ValidatableBox
103.  def validateOptionalIntegerAsEqualTo(box: CtBoxIdentifier with CtOptionalInteger, equalToBox: CtBoxIdentifier with CtOptionalInteger): Set[CtValidation]
     Attributes
       protected
     Definition Classes
       ValidatableBox
104.  def validateOptionalStringByLength(boxId: String, box: OptionalStringIdBox, min: Int, max: Int)(): Set[CtValidation]
     Attributes
       protected
     Definition Classes
       ValidatableBox
105.  def validateOptionalStringByLength(value: Option[String], min: Int, max: Int, boxId: String, boxIdPrefix: Option[String])(): Set[CtValidation]
     Definition Classes
       ExtraValidation
106.  def validateOptionalStringByLengthMax(boxId: String, box: OptionalStringIdBox, max: Int)(): Set[CtValidation]
     Attributes
       protected
     Definition Classes
       ValidatableBox
107.  def validateOptionalStringByLengthMin(boxId: String, box: OptionalStringIdBox, min: Int)(): Set[CtValidation]
     Attributes
       protected
     Definition Classes
       ValidatableBox
108.  def validateOptionalStringByRegex(boxId: String, box: OptionalStringIdBox, regex: String)(): Set[CtValidation]
     Attributes
       protected
     Definition Classes
       ValidatableBox
109.  def validatePositiveBigDecimal(box: OptionalBigDecimalIdBox)(): Set[CtValidation]
     Attributes
       protected
     Definition Classes
       ValidatableBox
110.  def validatePositiveInteger(box: OptionalIntIdBox)(): Set[CtValidation]
     Attributes
       protected
     Definition Classes
       ValidatableBox
111.  def validatePostcode(boxId: String, box: OptionalStringIdBox)(): Set[CtValidation]
     Definition Classes
       ValidatableBox
112.  def validatePostcode(boxId: String, postcode: Option[String]): Set[CtValidation]
     Definition Classes
       ExtraValidation
113.  def validatePostcodeLength(boxId: String, postcode: String): Set[CtValidation]
     Definition Classes
       ExtraValidation
114.  def validatePostcodeRegex(boxId: String, postcode: String): Set[CtValidation]
     Definition Classes
       ExtraValidation
115.  def validateRawStringByRegex(boxId: String, value: String, errorCodeBoxId: String, regex: String)(): Set[CtValidation]
     Attributes
       protected
     Definition Classes
       ValidatableBox
116.  def validateStringAsBlank(boxId: String, box: OptionalStringIdBox)(): Set[CtValidation]
     Attributes
       protected
     Definition Classes
       ValidatableBox
117.  def validateStringAsMandatory(boxId: String, box: OptionalStringIdBox)(): Set[CtValidation]
     Attributes
       protected
     Definition Classes
       ValidatableBox
118.  def validateStringAsMandatoryIfPAYEEQ1False(boxRetriever: RepaymentsBoxRetriever, boxId: String, box: OptionalStringIdBox)(): Set[CtValidation]
     Attributes
       protected
     Definition Classes
       ValidatableBox
119.  def validateStringAsMandatoryWithNoTrailingWhitespace(boxId: String, box: OptionalStringIdBox)(): Set[CtValidation]
     Attributes
       protected
     Definition Classes
       ValidatableBox
120.  def validateStringByLength(boxId: String, value: String, errorCodeId: String, min: Int, max: Int)(): Set[CtValidation]
     Definition Classes
       ValidatableBox
121.  def validateStringByLength(boxId: String, box: StringIdBox, min: Int, max: Int)(): Set[CtValidation]
     Attributes
       protected
     Definition Classes
       ValidatableBox
122.  def validateStringByRegex(boxId: String, box: StringIdBox, regex: String)(): Set[CtValidation]
     Attributes
       protected
     Definition Classes
       ValidatableBox
123.  def validateStringByRegex(boxId: String, str: String, regex: String): Set[CtValidation]
     Definition Classes
       ExtraValidation
124.  def validateStringMaxLength(boxId: String, value: String, max: Int)(): Set[CtValidation]
     Definition Classes
       ValidatableBox
125.  def validateZeroOrNegativeInteger(box: OptionalIntIdBox)(): Set[CtValidation]
     Attributes
       protected
     Definition Classes
       ValidatableBox
126.  def validateZeroOrPositiveBigDecimal(box: OptionalBigDecimalIdBox)(): Set[CtValidation]
     Attributes
       protected
     Definition Classes
       ValidatableBox
127.  def validateZeroOrPositiveInteger(box: OptionalIntIdBox)(): Set[CtValidation]
     Attributes
       protected
     Definition Classes
       ValidatableBox
128.  val validationSuccess: Set[CtValidation]
     Definition Classes
       ValidatableBox
129.  final def wait(): Unit
     Definition Classes
       AnyRef
     Annotations
       @throws( ... )
130.  final def wait(arg0: Long, arg1: Int): Unit
     Definition Classes
       AnyRef
     Annotations
       @throws( ... )
131.  final def wait(arg0: Long): Unit
     Definition Classes
       AnyRef
     Annotations
       @throws( ... ) @native()

### Inherited from Serializable

### Inherited from Product

### Inherited from Equals

### Inherited from SBACalculator

### Inherited from AccountingPeriodHelper

### Inherited from NumberRounding

### Inherited from SBAHelper

### Inherited from ValidatableBox[ComputationsBoxRetriever]

### Inherited from ExtraValidation

### Inherited from Validators

### Inherited from AnyRef

### Inherited from Any

### Ungrouped